/****************************************************************************

    PROGRAM: Wdic.c

    PURPOSE: Dictionnaire pour Windows. Portage Windows

Date: 1 Mai 1993
        Auteur : Serge Delbono
        ----------------------

Last Update: 23/3/99

  **** La recherche dans le dictionnaire est de Rene Cougnenc ****


****************************************************************************/

#include "wdic.h"                /* specific to this program       */

HANDLE hInst;                       /* current instance            */
HGLOBAL hSound;		/* Handle du son */

/****************************************************************************

    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

        Point d'entree de l'application
        -------------------------------

****************************************************************************/

int PASCAL WinMain(
HANDLE hInstance,                            /* current instance             */
HANDLE hPrevInstance,                        /* previous instance            */
LPSTR lpCmdLine,                             /* command line                 */
int nCmdShow)                                /* show-window type (open/icon) */
{

    /* Perform initializations that apply to a specific instance */

    lpArg = lpCmdLine ;
    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);
    return (TRUE) ;
}


/****************************************************************************

    FUNCTION:  InitInstance(HANDLE, int)

    PURPOSE:  Saves instance handle and creates main window

****************************************************************************/

BOOL InitInstance(
    HANDLE          hInstance,          /* Current instance identifier.       */
    int             nCmdShow)           /* Param for first ShowWindow() call. */
{

    /* Save the instance handle in static variable, which will be used in  */
    /* many subsequence calls from this application to Windows.            */

    hInst = hInstance;

    nligversion = 0 ;
    bHelpAppele = FALSE ;

    /* Create a main window for this application instance.  */


	if (DialogBox(hInst, MAKEINTRESOURCE (MAIN_DIAL), (HWND)NULL,
		MainDial)==-1)
	{
       MessageBox (GetFocus(), "Impossible de crer le dialogue !",
                         "Panic ! Win Dico",
                         MB_OK | MB_ICONSTOP) ;
        return FALSE ;
	}
	hWndMain=NULL ;
	if (hSound)
	{
		sndPlaySound(NULL,SND_SYNC) ;
		FreeResource(hSound) ;
	}
    return (TRUE);               /* Returns the value from PostQuitMessage */

}


/***************************************************/
/*          Boite de dialogue principale           */
/*          ----------------------------           */
/* On fait tout la-dedans que c'est pas possible ! */
/***************************************************/

BOOL FAR PASCAL MainDial (
HWND hDlg,                           /* window handle of the dialog box */
UINT message,                        /* type of message                 */
WPARAM wParam,                       /* message-specific information    */
LPARAM lParam)
{
    static HWND lastSubWin = 0 ;
    static int kiki ;           // gene aleatoire

    kiki ++;                    // a chaque message

    switch (message) {
        case WM_INITDIALOG:                /* message: initialize dialog box */
            hWndMain = hDlg ;   /* eh oui ! */
            LeDebut() ;
            return (TRUE);
            break ;

        case WM_CLOSE:
        case WM_DESTROY:
            OnSeCasse () ;        /* truc  faire en partant */
            return (TRUE);
            break ;

          case WM_SETCURSOR :
            {
              HWND hSubWin ;
              int item ;

// Essaie de mise a jour de la mini zone d'aide

              hSubWin = (HWND) wParam ;
              if (hSubWin==lastSubWin)
                return FALSE ;

              item = GetDlgCtrlID (hSubWin) ;
              switch (item) {
                  case MAIN_EDIT:
                  case MAIN_COPALL:
                  case MAIN_COP:
                  case MAIN_SOL:
                  case MAIN_ABOUT:
                  case MAIN_GO:
                  case MAIN_DICO:
                  case MAIN_EXIT:
                  case MAIN_HELP:
                  case MAIN_VOC:
                  case MAIN_CP:
                  case MAIN_STRICT:
		  case MAIN_SOUNDEX:
                     lastSubWin = hSubWin ;
                  break;

                  default:

                      // fenetre inconnue donc principale
                      if (lastSubWin == hDlg)
                      return FALSE ;
                      lastSubWin = hDlg ;
// On retourne une "fortune" :-))
                      item = FORTUNE+(unsigned)(rand()+kiki)%(unsigned)NB_FORT ;
                      ;
              } /* fin switch */
              LoadString (hInst, item ,szString,127) ;

              SetDlgItemText (hDlg, MAIN_AIDE, szString) ;
            }
            break;
            
  /*********************************************************/
  /*                                                       */
  /*       COMMANDES venant des elements de la boite       */
  /*                                                       */
  /*********************************************************/

        case WM_COMMAND:                   /* message: received a command */
            switch (wParam) {
              case MAIN_EXIT:
                  OnSeCasse () ;        /* truc  faire en partant */
                  return (TRUE);
                  break ;

              case MAIN_ABOUT:
                  DialogBox (hInst, MAKEINTRESOURCE (ABOUT), hDlg,
                                  About) ;
              case MAIN_EDIT:
                 return TRUE ;
                 break ;

               case MAIN_COPALL:
                 CopyAllToClip () ;
                 return TRUE ;
                 break;

               case MAIN_COP:
                     CopyToClip () ;
                     return TRUE ;
                 break;


               case MAIN_SOL:
                  switch (HIWORD(lParam)) {

                    case LBN_DBLCLK:
                      if (NbItem != 0)
                        CopyToClip () ;
                      else
                        MessageBeep (MB_ICONASTERISK) ;
                      break;

                    case LBN_ERRSPACE:
                        bListFull = TRUE ;
                        Fatal ("Y'a plus de place pour afficher !\n"
                        "Arrrrghhhhh") ;
                      break;


                    default:
                      ;
                  } /* fin switch */
                  return TRUE ;
                 break;

               case MAIN_DICO:
                 GetMainDico () ;
                 return TRUE ;
                 break;


               case MAIN_GO:
                 recherche () ;
                 return TRUE ;
                 break;

               case MAIN_HELP:
                 if (WinHelp (hDlg, PathHelp, HELP_CONTENTS,0))
                     bHelpAppele = TRUE ;
                 break;

               case MAIN_VOC:
                 bAutoVoc = ! bAutoVoc ;
                 if (bAutoVoc)
                    CheckDlgButton (hDlg, MAIN_VOC, MF_CHECKED) ;
                  else {
                    CheckDlgButton (hDlg, MAIN_VOC, MF_UNCHECKED) ;
                    if (!bAutoCP){
                      bAutoCP = TRUE ;
                      CheckDlgButton (hDlg, MAIN_CP, MF_CHECKED) ;
                    } /* fin if */
                 } /* fin if */
                 return TRUE ;

               case MAIN_CP :
                 bAutoCP = ! bAutoCP ;
                 if (bAutoCP)
                    CheckDlgButton (hDlg, MAIN_CP, MF_CHECKED) ;
                  else {
                    CheckDlgButton (hDlg, MAIN_CP, MF_UNCHECKED) ;
                    if (!bAutoVoc){
                      bAutoVoc = TRUE ;
                      CheckDlgButton (hDlg, MAIN_VOC, MF_CHECKED) ;
                    } /* fin if */
                 } /* fin if */
                 return TRUE ;
                 break ;
               case MAIN_STRICT :
                 bStrict = ! bStrict ;
                 if (bStrict)
                    CheckDlgButton (hDlg, MAIN_STRICT, MF_CHECKED) ;
                  else
                    CheckDlgButton (hDlg, MAIN_STRICT, MF_UNCHECKED) ;

		 bSoundex= FALSE ;
		 CheckDlgButton (hDlg,MAIN_SOUNDEX, MF_UNCHECKED) ;
                 break;

		case MAIN_SOUNDEX :
		  bSoundex= ! bSoundex ;
		  if (bSoundex) {
			CheckDlgButton (hDlg,MAIN_SOUNDEX, MF_CHECKED) ;
	                CheckDlgButton (hDlg, MAIN_STRICT, MF_UNCHECKED) ;
			bStrict=FALSE ;
		  } else {
			CheckDlgButton (hDlg,MAIN_SOUNDEX, MF_UNCHECKED) ;
		  }


              default:
                ;
            } /* fin switch wParam */
            break;

    } /* fin switch message */
    return (FALSE) ;

}

/****************************************/
/*    Calcul des coo d'un rectangle,    */
/*  des coo ecran vers les coo clients  */
/****************************************/

static void ScreenCoo (HWND hwnd, LPRECT rect)
{
  POINT p1, p2 ;
  p1.x = rect->left ;
  p1.y = rect->top ;
  ScreenToClient (hwnd,&p1) ;
  p2.x = rect->right ;
  p2.y = rect->bottom ;
  ScreenToClient (hwnd,&p2) ;
  rect->left = p1.x ;
  rect->top  = p1.y ;
  rect->right = p2.x ;
  rect->bottom = p2.y ;
}


/****************************************************************************

    FUNCTION: About(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages for "About" dialog box

    MESSAGES:

        WM_INITDIALOG - initialize dialog box
        WM_COMMAND    - Input received

    COMMENTS:

        No initialization is needed for this particular dialog box, but TRUE
        must be returned to Windows.

        Wait for user to click on "Ok" button, then close the dialog box.

****************************************************************************/

BOOL FAR PASCAL About(
HWND hDlg,                            /* window handle of the dialog box */
UINT message,                         /* type of message                 */
WPARAM wParam,                        /* message-specific information    */
LPARAM lParam)
{
  HFONT hfontDlg ;
  LOGFONT lFont ;
  PAINTSTRUCT ps;
  static HBITMAP hBitmap ;
  BITMAP bm ;
  HDC hDC, hMemDC ;
  RECT rect ;
  HWND hEdit ;
  char *pText ;
  int lentext ;


//  FARPROC lpProcAbout2;        /* pointer to the "About" function */
    switch (message) {
        case WM_INITDIALOG:                /* message: initialize dialog box */
// Hommage a Rene en plus petit
         hfontDlg = (HFONT) NULL;

          if ((hfontDlg = (HFONT) SendMessage(hDlg, WM_GETFONT, 0, 0L))) {
           if (GetObject(hfontDlg, sizeof(LOGFONT), (LPSTR) &lFont)) {
             lFont.lfHeight = (lFont.lfHeight*4)/5 ;
             lFont.lfWidth = (lFont.lfWidth*4)/5 ;
             lFont.lfItalic = 1 ;
             if (hfontDlg = CreateFontIndirect((LPLOGFONT) &lFont)) {
                SendDlgItemMessage (hDlg, ABOUT_COP1, WM_SETFONT,
                (WPARAM) hfontDlg, 0);
             }
            }
    	   }
		   hBitmap = LoadBitmap (hInst, "TRONCHE") ;
		   play("SND_NAT") ;
           return (TRUE);

		case WM_PAINT:
				BeginPaint (hDlg,&ps);
				hDC = GetDC (hDlg) ;
				hMemDC = CreateCompatibleDC (hDC) ;
				SetMapMode (hMemDC, GetMapMode (hDC) ) ;
				SelectObject (hMemDC, hBitmap) ;
				GetObject (hBitmap, sizeof ( BITMAP ), (LPSTR) &bm) ;
		        GetWindowRect (GetDlgItem(hDlg,MAIN_PHOTO),&rect) ;
				ScreenCoo (hDlg,&rect) ;

				BitBlt (hDC,rect.left,rect.top,bm.bmWidth,bm.bmHeight,hMemDC,0,0,
                    SRCCOPY) ;

				DeleteDC (hMemDC) ;
				ReleaseDC (hDlg, hDC) ;
				EndPaint(hDlg,&ps);

	        break;
           

        case WM_COMMAND:                      /* message: received a command */
            if (wParam == IDOK                /* "OK" box selected?          */
                || wParam == IDCANCEL) {      /* System menu close command? */
	            DeleteObject (hBitmap) ;
                EndDialog(hDlg, TRUE);        /* Exits the dialog box        */
                return (TRUE);
            }
            if (wParam == ABOUT_DIC){
              DialogBox (hInst, MAKEINTRESOURCE (ABOUT2), hDlg,
                               About2) ;
              DeleteObject (hBitmap) ;
              EndDialog(hDlg, TRUE);        /* Exits the dialog box        */
              return (TRUE) ;
            } /* fin if */
            if (wParam == ABOUT_HTTP) {
				hEdit =GetDlgItem (hDlg,ABOUT_HTTP) ;
				lentext = GetWindowTextLength (hEdit) ;
				if (lentext <= 0){ // rien dans la boite edit
				    MessageBeep (MB_ICONASTERISK) ;
				    return ;
				  } /* fin if */
				pText = malloc (lentext+4) ;
				if (pText==NULL){
			    	Fatal ("(cherche) plus de mmoire !") ;
				    return ;
				} /* fin if */
				GetWindowText (hEdit, pText, lentext+4) ;
				ShellExecute(hDlg,"open",pText,NULL,".",SW_SHOWNORMAL) ;
				free (pText) ;
	            return TRUE ;
            }
            break;
    }
    return (FALSE);                           /* Didn't process a message    */
}

/****************************************************************************

    FUNCTION: About2(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages for "About2" dialog box

    MESSAGES:

        WM_INITDIALOG - initialize dialog box
        WM_COMMAND    - Input received

    COMMENTS:

        No initialization is needed for this particular dialog box, but TRUE
        must be returned to Windows.

        Wait for user to click on "Ok" button, then close the dialog box.

****************************************************************************/

BOOL FAR PASCAL About2(
HWND hDlg,                            /* window handle of the dialog box */
UINT message,                         /* type of message                 */
WPARAM wParam,                        /* message-specific information    */
LPARAM lParam)
{
    switch (message) {
        case WM_INITDIALOG:                /* message: initialize dialog box */
            SetDlgItemText (hDlg, AB2_TEXT, versiondico) ;
            return (TRUE);
            break ;

        case WM_PAINT:
            SetDlgItemText (hDlg, AB2_TEXT, versiondico) ;
            return FALSE ;
            break ;

        case WM_COMMAND:                      /* message: received a command */
            if (wParam == IDOK                /* "OK" box selected?          */
                || wParam == IDCANCEL) {      /* System menu close command? */
                EndDialog(hDlg, TRUE);        /* Exits the dialog box        */
                return (TRUE);
            }
            break;
    }
    return (FALSE);                           /* Didn't process a message    */
}

/////////////////////////////////////////////////////////////////////////////
// Sound helpers

void play(LPCSTR son)
{
      HRSRC hRes; // resource handle to wave file
	
	if (hSound)
	{
		sndPlaySound(NULL,SND_SYNC) ;
		FreeResource(hSound) ;
	}

    if ((hRes = FindResource (hInst, son,RT_RCDATA)) != NULL &&
     (hSound = LoadResource(hInst, hRes)) != NULL)
     {
    // found the resource, play it
		sndPlaySound ((LPCSTR) LockResource(hSound),SND_MEMORY|SND_ASYNC);
    }
}

  /*****************************************/
  /*                                       */
  /*     Les trucs a faire en partant      */
  /*                                       */
  /*****************************************/

void OnSeCasse (void)
{
	
	if (bHelpAppele) WinHelp (hWndMain, PathHelp, HELP_QUIT, 0) ;
	EndDialog (hWndMain, TRUE);   /* Exits the dialog box        */
	PostQuitMessage(0);

}

/*******************************************/
/*                                         */
/*       Les trucs a faire au debut        */
/*                                         */
/*******************************************/

void LeDebut ()
{
  HCURSOR hCurw ;
  HFONT hfontDlg ;
  LOGFONT lFont ;
  char *p ;
// Mise du bon icone, en cas de minimization
  SetClassLong (hWndMain, GCL_HICON, (LONG)LoadIcon (hInst, "WDIC")) ;

// Recupere nom du fichier d'aide
  MakeHelpPathName (PathHelp) ;

  SetCursor (hCurw = LoadCursor (NULL, IDC_ARROW) ) ;
  SetClassWord (hWndMain, GCL_HCURSOR, (LONG)hCurw) ;

  nligversion = 0 ;
  bHelpAppele = FALSE ;
  NbItem = 0 ;
  hSound = NULL ;
  SetDlgItemText (hWndMain, MAIN_MOTS,"Pas de mots") ;
//  Recup du parametre
// Avec LCC on a aussi le nom du programme
  
  p = lpArg ;
  if (*p = '"') { // Noms longs : peut y avoir de blancs !
  	p++;
  	while ((*p!='\0') && (*p !='"')) p++ ;
  	if (!*p) goto noarg ;
  	p++ ;
  } else {
	while ((*p!='\0') && (*p !=' ')) p++ ;
  }
  while ((*p!='\0') && (*p ==' ')) p++ ;
  if(p) SetDlgItemText (hWndMain, MAIN_EDIT,p) ;
noarg:

  srand ((unsigned) hWndMain + (unsigned)hInst + (unsigned)time(NULL)) ;

  /// Checker les boutons !!!
  CheckDlgButton (hWndMain, MAIN_VOC, MF_CHECKED) ;
  CheckDlgButton (hWndMain, MAIN_CP, MF_CHECKED) ;
  CheckDlgButton (hWndMain, MAIN_STRICT, MF_UNCHECKED) ;
  CheckDlgButton (hWndMain, MAIN_SOUNDEX, MF_UNCHECKED) ;

  bAutoVoc = bAutoCP = TRUE ;
  bStrict = FALSE ;
  bSoundex = FALSE ;

// Miniaide en italique

  hfontDlg = (HFONT) NULL;

  if ((hfontDlg = (HFONT) SendMessage(hWndMain, WM_GETFONT, 0, 0L))) {
     if (GetObject(hfontDlg, sizeof(LOGFONT), (LPSTR) &lFont)) {
       lFont.lfItalic = 1 ;
       lFont.lfWeight = FW_THIN ;
       lFont.lfHeight = (lFont.lfHeight*4)/5 ;
       lFont.lfWidth = (lFont.lfWidth*4)/5 ;
       
       if (hfontDlg = CreateFontIndirect((LPLOGFONT) &lFont)) {
         SendDlgItemMessage (hWndMain, MAIN_AIDE, WM_SETFONT,
           (WPARAM) hfontDlg, 0);
       }
     }
   }

  GetPrivateProfileString ("WinDico","path","",PathDic,sizeof(PathDic),"sdelbono.ini") ;
  // Test la presence d'un dictionnaire [au moins version.dic])
//  _fullpath (PathDic,PathDic,_MAX_PATH) ;
  if ( PathDic[strlen(PathDic)-1] !='\\') strcat (PathDic,"\\") ;
  if (TestDico (PathDic))
     WritePrivateProfileString ("WinDico","path",PathDic,"sdelbono.ini") ;

}
/*******************************************************************/
/*                                                                 */
/*  Test la presence du dictionnaire, et eventuellement recupere   */
/*  le texte de definition la version                              */
/*                                                                 */
/*******************************************************************/
BOOL TestDico (LPSTR path)
{
  char filevers [_MAX_PATH] ;
  char *p ;
  FILE *fi ;
  int i ;
  AnsiToOem (path, filevers) ;
  strcat (filevers,VERSION_FILE) ;
  fi = fopen (filevers,"r") ;
  if (fi==NULL){
    MessageBeep (MB_ICONSTOP) ;
    MessageBox (hWndMain,"Fichiers dictionnaires non trouvs",
    "Dico pour Windows",MB_OK | MB_ICONSTOP) ;
    return FALSE ;
  } /* fin if */
  nligversion = 0 ;
  p = versiondico ;
  for (i=0;i<10 ;i++ ){
      if (! fgets (p,59,fi) ) break ;
      p+= strlen(p);
  } /* fin for */
  fclose (fi) ;
  SetDlgItemText (hWndMain,MAIN_LOC,path) ;
  return TRUE ;
}

/***********************************/
/*                                 */
/*    Obtention du path du dico    */
/*                                 */
/***********************************/
void GetMainDico (void)
{
  char filename [_MAX_PATH] ;    // Nom du fichier

  static OPENFILENAME stOpf = {
    sizeof (struct tagOFN), // DWORD   lStructSize;
    0,                      // HWND    hwndOwner;
    0,                      // HINSTANCE hInstance;
    "Fichiers dicos(*.dic)\0*.dic\0\0", // LPCSTR  lpstrFilter;
    NULL,                   // LPSTR   lpstrCustomFilter;
    0,                      // DWORD   nMaxCustFilter;
    1,                      // DWORD   nFilterIndex;
    NULL,                   // LPSTR   lpstrFile;
    sizeof (filename),      // DWORD   nMaxFile;
    "version.dic",          // LPSTR   lpstrFileTitle;
    _MAX_FNAME,             // DWORD   nMaxFileTitle;
    PathDic,                // LPCSTR  lpstrInitialDir;
    "Rpertoire dictionnaire", // LPCSTR  lpstrTitle;
    OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|
    OFN_READONLY|OFN_HIDEREADONLY|OFN_EXPLORER,  // DWORD   Flags;
    0,                      // UINT    nFileOffset;
    0,                      // UINT    nFileExtension;
    "dic",                  // LPCSTR  lpstrDefExt;
    0   ,                   // LPARAM  lCustData;
    NULL,                   // UINT    (CALLBACK *lpfnHook)(HWND, UINT, WPARAM, LPARAM);
    NULL                    // LPCSTR  lpTemplateName;
  } ;

  stOpf.Flags =
   OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST| OFN_READONLY |OFN_HIDEREADONLY
      ;
  stOpf.lpstrFile = filename ;
  filename[0] = '\0' ;

  if ( GetOpenFileName (&stOpf)){
    filename [stOpf.nFileOffset] = '\0' ;
    strcpy (PathDic, filename) ;
    if (TestDico (PathDic))
     WritePrivateProfileString ("WinDico","path",PathDic,"sdelbono.ini") ;
  } /* fin if */
}

#ifdef PASFINI
/*******************************************/
/*                                         */
/*   *** Fonctions non implementees ***    */
/*                                         */
/*******************************************/
void PasLa (char *quoi)
{
  MessageBeep (MB_ICONSTOP) ;
  MessageBox (hWndMain,quoi,"Win Dico - Non implment",MB_OK|MB_ICONSTOP) ;
}
#endif // PASFINI

/***********************************/
/*                                 */
/*      Fatal erreur !!!!!!!       */
/*                                 */
/***********************************/

void Fatal (char *quoi)
{
  MessageBeep (MB_ICONSTOP) ;
  if (hWndMain)
	  MessageBox (hWndMain,quoi,"Win Dico - Erreur Fatle",MB_OK|MB_ICONSTOP) ;
	else
	  MessageBox (GetFocus(),quoi,"Win Dico - Erreur Fatle",MB_OK|MB_ICONSTOP) ;
	
}



/****************************************************************************

   FUNCTION:   MakeHelpPathName

   PURPOSE:   Recupere le path du fichier d'aide
              Tire directement de "HELPEX" des exemples mickeysoft.

****************************************************************************/

void MakeHelpPathName(char * szFileName)
{
   char *  pcFileName;
   int     nFileNameLen;

   nFileNameLen = GetModuleFileName (hInst,szFileName,_MAX_PATH);
   pcFileName = szFileName + nFileNameLen;

   while (pcFileName > szFileName) {
       if (*pcFileName == '\\' || *pcFileName == ':') {
           *(++pcFileName) = '\0';
           break;
       }
   nFileNameLen--;
   pcFileName--;
   }

   if ((nFileNameLen+13) < _MAX_PATH)
       lstrcat(szFileName, "wdic.hlp");
   else
       lstrcat(szFileName, "?");

   return;
}

/*******************************************/
/*                                         */
/*     Recherche en soit dans le dico      */
/*                                         */
/*******************************************/

void recherche(void)
{
  int lentext ;
  HWND hEdit ;
  char *pText ;
  HCURSOR hPrevCurs, hCurw ;

  hEdit =GetDlgItem (hWndMain,MAIN_EDIT) ;
  lentext = GetWindowTextLength (hEdit) ;
  if (lentext <= 0){ // rien dans la boite edit
    MessageBeep (MB_ICONASTERISK) ;
    return ;
  } /* fin if */
  pText = malloc (lentext+4) ;
  if (pText==NULL){
    Fatal ("(cherche) plus de mmoire !") ;
    return ;
  } /* fin if */
  GetWindowText (hEdit, pText, lentext+4) ;
  if (!bStrict) lstrcat (pText,"*") ;

  hEdit = GetDlgItem (hWndMain,MAIN_SOL) ;
  SendMessage (hEdit, LB_RESETCONTENT, 0, 0L) ;

  EnableWindow (GetDlgItem (hWndMain, MAIN_COP), FALSE) ;
  EnableWindow (GetDlgItem (hWndMain, MAIN_COPALL), FALSE) ;
  hPrevCurs = SetCursor (hCurw = LoadCursor (NULL, IDC_WAIT) ) ;
  SetClassLong (hWndMain, GCL_HCURSOR, (long) hCurw) ;

   SetDlgItemText (hWndMain, MAIN_MOTS,"Pas de mots") ;
   bListFull = FALSE ;

// Recherche proprement dite

  if( ! IsCharAlphaNumeric (pText[0]) )
            lookall( pText, hEdit );
        else
            lookfor( pText, hEdit) ;

  SetCursor (hPrevCurs) ;
  SetClassLong (hWndMain, GCL_HCURSOR, (long) hPrevCurs) ;
  EnableWindow (GetDlgItem (hWndMain, MAIN_COP), NbItem!=0) ;
  EnableWindow (GetDlgItem (hWndMain, MAIN_COPALL), NbItem!=0) ;
  if (NbItem!=0){
    // trouve : la main sur la liste
    SetFocus (GetDlgItem (hWndMain,MAIN_SOL) ) ;
  } else {
    // Pas trouve : la main sur la resaisie
    SetFocus (GetDlgItem (hWndMain, MAIN_EDIT) ) ;
  } /* fin if */
  free (pText) ;
  MessageBeep (MB_ICONASTERISK) ;

}

/*******************************************/
/*                                         */
/*      Attente pendant les longueurs      */
/*                                         */
/*******************************************/
void GotoBistrot ()
{
    MSG msg;                     /* message */

    while (PeekMessage( (LPMSG)&msg,0, 0, 0, TRUE))
    {
        TranslateMessage(&msg);    /* Translates virtual key codes           */
        DispatchMessage(&msg);     /* Dispatches message to window           */
    }
}

/*******************************************************************/
/*                                                                 */
/*    Copie de la selection dans la listebox vers le clipboard     */
/*                                                                 */
/*******************************************************************/

void CopyToClip ()
{
  LPBYTE pbuf ;
  HGLOBAL hbuf ;
  int nsel ;
  HWND hList ;
  WORD lenbuf ;

  hList = GetDlgItem (hWndMain, MAIN_SOL) ;
  nsel = SendMessage (hList, LB_GETCURSEL,0, 0L) ;
  if ((nsel>=0) && (lenbuf=SendMessage (hList, LB_GETTEXTLEN, nsel, 0L))) {
    hbuf = GlobalAlloc (GHND, lenbuf+1) ;
    if (!hbuf){
      Fatal ("(clip) Plus de mmoire !") ;
      return ;
     } /* fin if */
    pbuf = GlobalLock (hbuf) ;
    SendMessage (hList, LB_GETTEXT, nsel, (DWORD) pbuf) ;
    GlobalUnlock (hbuf) ;
    if (OpenClipboard(hWndMain)){
      EmptyClipboard () ;
      SetClipboardData (CF_TEXT, hbuf) ;
      CloseClipboard () ;
    }
    else GlobalFree (hbuf) ;
  }
}

/* Copie tout vers le clipboard */
/* optimisation a enlever pour lcc < 17/9/97) */
/* #pragma optimize(0) */
void CopyAllToClip ()
{
  LPBYTE pbuf ;
  HGLOBAL hbuf ;
  HGLOBAL hbufx ;
  int nbitem ;
  int item ;
  HWND hList ;
  DWORD lenbuf ;
  WORD lenline ;
  char ligne[100] ;
  HCURSOR hPrevCurs, hCurw ;

  hList = GetDlgItem (hWndMain, MAIN_SOL) ;
  nbitem = SendMessage (hList, LB_GETCOUNT,0, 0L) ;
  if (nbitem <= 0)
  {
      Fatal ("(clip) Liste vide !") ;
      return ;
  }
  pbuf=NULL ;
  hbuf=NULL ;
  lenbuf=0 ;
  hPrevCurs = SetCursor (hCurw = LoadCursor (NULL, IDC_WAIT) ) ;
  SetClassLong (hWndMain, GCL_HCURSOR, (long) hCurw) ;
  for (item=0; item < nbitem; item++)
  {
  	lenline=SendMessage(hList,LB_GETTEXT,item,(DWORD)ligne) ;
  	if (pbuf)
  	{
  		lenbuf += (lenline+3) ;
  		GlobalUnlock(hbuf) ;
  		if ((hbufx=GlobalReAlloc(hbuf,lenbuf,GMEM_MOVEABLE))==NULL) {
			Fatal ("(clip) Plus de mmoire !") ;
			GlobalFree(hbuf) ;
			return ;
  		}
  		hbuf=hbufx ;
  		pbuf = GlobalLock (hbuf) ;
  		lstrcat(pbuf,"\r\n") ;
  		lstrcat(pbuf,ligne) ;
  	} else {
  		lenbuf=lenline+3 ;
  		hbuf=GlobalAlloc(GHND,lenbuf) ;
  		pbuf=GlobalLock(hbuf) ;
  		lstrcpy(pbuf,ligne) ;
  	}
  }
  GlobalUnlock (hbuf) ;
  if (OpenClipboard(hWndMain)){
      EmptyClipboard () ;
      if (!SetClipboardData (CF_TEXT, hbuf))
      {
      	Fatal ("(Clip) SetClipBardData error") ;
      }
      CloseClipboard () ;
  } else GlobalFree (hbuf) ;
  SetCursor (hPrevCurs) ;
  SetClassLong (hWndMain, GCL_HCURSOR, (long) hPrevCurs) ;
}

